#include "gif.h"

enum COLOR_INDEX{RED=0, GREEN=1, BLUE=2, ALPHA=3};

void drawSquare(uint8_t* image, const uint32_t radius, const uint32_t xcoor, const uint32_t ycoor, const uint32_t width, const uint32_t height)
{
    for(uint32_t y=ycoor-radius; y<=ycoor+radius; y++)
        for(uint32_t x=xcoor-radius; x<=xcoor+radius; x++){
                uint32_t index = 4 * (y * width + x);
                image[index + RED] = image[index + GREEN] = image[index + ALPHA] = (radius*5)%256;
                image[index + BLUE] = 0;
            }
}

void drawFrame(GifWriter& gWriter, const uint32_t radius, const uint32_t height, const uint32_t width, const uint32_t delay)
{
    uint8_t* image = new uint8_t[4*height*width]();
    drawSquare(image, radius, width/2, height/2, width, height);
    GifWriteFrame(&gWriter, image, width, height, delay);
    delete[] image;
}

int main() {
    const uint32_t width = 101, height = 101, delay = 1;
    GifWriter gWriter;
    GifBegin(&gWriter, "animation.gif", width, height, delay);
    for (uint32_t i = 0; i < width/2; i++)
        drawFrame(gWriter, i, height, width, delay);
    return GifEnd(&gWriter);
}